# -----------   STARTER CODE -------------------------------

.data	  
	
sizeBuffer:	.word   0	# dummy value:  real value will be entered by user
stringRefArray:	.space 20       # allocate bytes for the array of 5 starting addresses of strings 
strings:	.space 100	# allocate 100 bytes for all the strings		
maxLenStrPrompt:
		.asciiz		"ENTER MAX LENGTH STRING: "	
stringPrompt:
		.asciiz		"ENTER STRING : "	
newline:	.asciiz		"\n"	
numStringsMessage:
		.asciiz		"NUMBER OF STRINGS IS "	
enumerate:	.asciiz		".) "	
MTF:		.asciiz		"MOVE TO FRONT ITEM (ENTER NUMBER) : "
exitMessage:	.asciiz		"BYE FOR NOW !"

.text  
       
main:  	 				


#  print prompt  to enter maximum length of a string
 
	la	$a0, maxLenStrPrompt	
	li	$v0, 4
	syscall 	

#  read maximum length of string buffer,  read value goes into $v0
	li	$v0, 5
	syscall 	

#  If user specifies that string is at most N characters, then we need a buffer for 
#  reading the string that is at least size = N+1 bytes.  The reason is that the
#  syscall will append a \0 character.  If the entered string is less than N
#  bytes, then the syscall will append \n\0.

#   Store the value size = N+1 in Memory.  This is the size of the buffer that syscall needs.

  	addi	$v0, $v0, 1  
	la	$t0,  sizeBuffer
	sw	$v0, 0($t0)

# ---------------  ADD YOUR CODE BELOW HERE  -------------------------------


#  $s0 counts the number of strings entered by user 
#  $s1 holds the address where the current string starts
#  $s2 counts the number of chars in the current string
#  $s3 points to character in string as we walk through the string
#  $s4 holds a character
#  $s5 holds the address of the current array element (a pointer to string)

#  initialize variables 

	add	 $s0, $zero, $zero         # number of strings entered		
	la	 $s1, strings		   # address where the current string starts
        add	 $s3, $s1, $zero 	   # address of current character in string
	la	 $s5, stringRefArray       # address of array element

#   now enter a loop to read the strings

enterNextString:  

	la	$a0, stringPrompt	#  print prompt to console to enter string
	li	$v0, 4
	syscall            	

	add	$a0, $zero, $s1		#  read in a string starting at address $s1
	la	$t0, sizeBuffer
	lw	$a1, 0($t0)             #  a1 is the size of the buffer
	li	$v0, 8	                #  v0 is the code for reading string
	syscall

#  initialize variables for counting ($s2) and indexing ($s3) the characters in the string.  

	add	 $s2, $zero, $zero      
	add	 $s3, $s1,  $zero 

beginCountCharLoop:

        lb	 $s4, 0($s3)		# Load the next character into $s4
	addi	 $s3, $s3, 1		# Advance the index to the next character
 
 	li 	 $t0, 10		#  (ascii 10 is line feed)

					# Test if the character is a line feed.  
					# If so, the string is done, so exit loop.
	beq 	 $s4, $t0, exitCountCharLoop   
	beqz 	 $s4, bufferFull   
					
 	addi	 $s2, $s2, 1		# increment the counter of number of 	
					# characters in this string

	j	beginCountCharLoop

bufferFull:

#	If here, then the string entered had sizeBuffer-1 characters 
#	followed by \0, rather than linefeed.  $s3 will be one bigger than the
#	maximum length.  So put a null terminator at the end, and put a 
#       line feed right before it. 

#	addi	$t0, $zero, 10		#  (ascii 10 is line feed)
	sb	$zero, 0($s3)		#  put null terminator in last char
	sb	$t0, -1($s3)		#  put a line feed before it
	
exitCountCharLoop:  	

# If the string just entered had no characters, then we're done entering strings.

	beq	$s2, $zero, doneEnteringStrings   

# else skip over the \0 byte which terminates the string we just read and point
#      location where next string will begin

	addi	 $s3, $s3, 1		

# Echo the string just entered by user. 

	add	$a0,$s1, $zero		 
	li	$v0,4
	syscall
#
#
#    We now need to put the starting address of the current string into the array,
#    so that we can reference it later. 
#
#     $s1 holds the address where the current string begins
#     $s5 holds the array address (in Memory) where we need to store 
#     the reference to the current string 

	sw	 $s1,  0($s5)		#  Store the starting address of the current string

#   $s3 holds the address where the next string will begin

	add	 $s1,  $s3, $zero	#  Re-initialize the starting location of next string
 	addi	 $s5, $s5, 4 		#  Update $s5 to point to next array location.
	addi	 $s0, $s0, 1 		#  Increment number of strings

#	$s2 holds the number of characters of the current string.
#	If it is not zero, then loop back and get another string.

	bne	$s2, $zero, enterNextString
	
doneEnteringStrings:

	la	$a0,newline		# print a newline 
	li	$v0,4
	syscall
			
#  ---------------   Print out list of strings ------------------		

printListOfStrings:
	
	la	$a0,numStringsMessage	# print  "number of strings : "
	li	$v0,4
	syscall

	li	$v0, 1			# print number of strings
	move	$a0, $s0
	syscall
	
	beq	$s0, $zero, EndMTF	#  if no strings were entered, then exit.

	la	$a0,newline		# print a newline 
	li	$v0,4
	syscall

BigLoop:
	la	$s5, stringRefArray	# reinitialize $s5 to first array element 
 	add	$t2, $zero, $zero	# t2 will count the strings

PrintListOfStrings:

	#  print index of current string, followed by punctuation
	
	move	$a0, $t2		# index of string
	li	$v0, 1
	syscall

	la	$a0, enumerate		# print ".) " 
	li	$v0, 4
	syscall

	#  print the current string

	lw	$a0, 0($s5)		
	li	$v0,4
	syscall

	# advance to next string (unless we have counted all the strings: in that case, ready to exit)

	addi	$s5, $s5, 4		#  increment address of next array element
	addi	$t2, $t2, 1		#  increment number of strings counter
	beq	$t2, $s0, BeginMTF
	j 	PrintListOfStrings

#  -----------------     move-to-front  --------------------------

#  We are not going to do anything with the strings here.  Instead we are just going
#  to manipulate the references to the strings.

#  $s0 counts the number of strings entered by user  [as before] 
#  $s1 has starting address of the selected string (saved)
#  $s2 holds an integer array index j
#  $s3 will be be the moving address that indexes into the array
#  $s4 
#  $s5 holds the address in the current array element (a pointer to string)   [as before]


BeginMTF:

	la	$a0, MTF		# print move-to-front message 
	li	$v0,4
	syscall

	li	$v0, 5			# read in the index
	syscall

	slt	$t3, $v0, $s0		# Check if user's index is greater than number of strings.  
					#  (if so, then goto EndMTF)
	beq	$t3, $zero, EndMTF	


#   Compute the address of array slot holding the reference to the selected string

	la	$s5, stringRefArray	# starting address of the array of string references

	sll	$t0, $v0, 2		# compute offset (4 bytes per word)
	add	$s5, $s5, $t0		# $s5 has reference to starting address of selected string
	lw	$s1, 0($s5)		# load into $s1 the starting address of the string   
					# (save it for later)

#   Let selected reference be index j.  Shift references j-1 downto 0 to locations j downto 1.

	add	$s2, $v0, $zero		# $s2 holds j
	add	$s3, $s5, $zero		# $s3 will be the moving address that indexes into the array

BeginShift:    

	beq	$s2, $zero, EndShift    #  if j == 0, we are done,  else pass from j-1 to j

	lw	$t6, -4($s3)	        #  copy from slot j-1 to j
	sw	$t6,  0($s3)	          

	addi	$s3, $s3, -4 		#  Update array reference and index j.
	addi	$s2, $s2, -1
	j	BeginShift

EndShift:
	sw	$s1, 0($s3)		#  put saved address of string at array element 0
 
	j	BigLoop

EndMTF:

	la	$a0, exitMessage	
	li	$v0, 4
	syscall 

	li	$v0, 10			# exit
	syscall
	nop 
